<template>
  <v-app>
    <!-- session start-->
    <v-dialog v-model="dialogtimeout" persistent width="420">
      <v-card>
        <v-card-title class="headline">Session Expired</v-card-title>
        <div style="padding-left:20px;">
          You have left this browser for 5 minutes. Please Login again.
        </div>
        <v-card-actions>
          <br /><br /><br />
          <v-spacer></v-spacer>
          <center>
            <v-btn style="color:white;" color="#6a7d69" text @click="logout"
              >OK</v-btn
            >
          </center>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- session end-->

    <!-- ----------------------------- Desktop navi ------------------------------->
    <v-navigation-drawer
      permanent
      width="290"
      v-model="drawer"
      :mini-variant.sync="mini"
      app
      v-if="!mobileView"
      class="items"
    >
      <v-toolbar flat class="transparent">
        <v-list class="pa-0">
          <v-list-tile avatar>
            <v-list-tile-content wrap>
              <v-toolbar-title
                v-if="!mobileView"
                style="color:#6a7d69; font-size:16px; margin-right:7px;"
              >
                <img
                  medium
                  style="width: 77px; height: 52px;"
                  :src="images.logoinet"
              /></v-toolbar-title>
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
      </v-toolbar>

      <!--  tab for user -->
      <v-list style="padding:0px;" v-if="role == 'User'">
        <v-list-tile
          v-for="item in itemsuser"
          :key="item.title"
          :to="item.path"
          active-class="sidemenu"
          color="primary"
        >
          <v-list-tile-action>
            <img :src="item.icon" />
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>{{ item.title }}</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
        <p hidden>test{{ isIdle }}</p>
      </v-list>

      <!-- tab for admin -->
      <v-list class="pt-4" v-if="role == 'Admin'">
        <v-list-tile
          v-for="item in itemsadmin"
          :key="item.title"
          :to="item.path"
          @click="exportfrom = item.value"
          active-class="sidemenu"
        >
          <v-list-tile-action>
            <img :src="item.icon" />
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>
              {{ item.title }}
            </v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
      </v-list>
    </v-navigation-drawer>
    <!-- ----------------------------- End Desktop ------------------------------->

    <!-- ----------------------------- Mobile ----------------------------- -->
    <v-navigation-drawer
      style="position:fixed; overflow-y:scroll;"
      v-if="mobileView"
      temporary
      width="260"
      v-model="drawer"
      absolute
      app
    >
      <v-toolbar flat class="transparent">
        <v-list>
          <v-list-tile>
            <v-list-tile-content>
              <img
                medium
                style="width: 77px; height: 52px;"
                :src="images.logoinet"
              />
            </v-list-tile-content>
          </v-list-tile>
        </v-list>
      </v-toolbar>

      <!-- tab for user -->
      <v-list class="pt-4" v-if="role == 'User'">
        <v-list-tile
          v-for="item in itemsuser"
          :key="item.title"
          :to="item.path"
          active-class="sidemenu"
          color="primary"
        >
          <v-list-tile-action>
            <img :src="item.icon" />
          </v-list-tile-action>

          <v-list-tile-content>
            <v-list-tile-title>{{ item.title }}</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
      </v-list>

      <!-- tab for admin -->
      <v-list class="pt-4" v-if="role == 'Admin'">
        <v-list-tile
          v-for="item in itemsadmin"
          :key="item.title"
          :to="item.path"
          @click="exportfrom = item.value"
          active-class="sidemenu"
        >
          <v-list-tile-action>
            <img :src="item.icon" />
          </v-list-tile-action>
          <v-list-tile-content>
            <v-list-tile-title>{{ item.title }}</v-list-tile-title>
          </v-list-tile-content>
        </v-list-tile>
      </v-list>
    </v-navigation-drawer>
    <!-- ----------------------------- End Mobile ----------------------------- -->

    <v-toolbar color="white" app class="elevation-1">
      <v-toolbar-title style="margin-left:0px;">
        <v-btn icon @click.stop="drawer = !drawer" v-if="mobileView">
          <v-icon color="#6a7d69">mdi-view-headline</v-icon>
        </v-btn></v-toolbar-title
      >
      <v-spacer></v-spacer>
      <v-layout style="margin-top:5px">
        <v-flex xs3></v-flex>
        <v-flex xs3></v-flex>
        <v-flex xs8>
          <!-- select bar for admin -->
          <v-select
            v-if="role == 'Admin'"
            outline
            :items="itemsCompany"
            placeholder="Select company"
            name="select company"
            style="font-family: Sarabun, sans-serif;"
            v-model="companyName"
          ></v-select>
          <!--  end select bar for admin -->
        </v-flex>
      </v-layout>
      <v-layout v-if="mobileView">
        <v-flex xs12> </v-flex>
        <v-flex xs2></v-flex>
      </v-layout>
      <img
        v-if="userimage !== 'null'"
        style="width: 40px; height: 40px;margin-left:10px;border-radius: 50%;"
        :src="'data:image/jpeg;base64,' + userimage"
      />
      <img
        v-if="userimage == 'null'"
        style="width: 40px; height: 40px;margin-left:10px;border-radius: 50%;font-family: Sarabun, sans-serif;"
        :src="images.user"
      />
      <v-toolbar-title>
        <div
          style="color:#333333; font-size:14px; margin-right:7px; margin-left:7px; font-weight:400; font-style: normal;font-family: Sarabun, sans-serif;"
        >
          {{ firstlastTH }}
        </div>
        <div
          style="color:#757575; font-size:12px; margin-right:7px; margin-left:7px; font-weight:400; font-style: normal;font-family: Sarabun, sans-serif;"
        >
          {{ bizNameTH }}
        </div>
      </v-toolbar-title>
      <img
        medium
        @click="logout"
        style="width: 22px;cursor:pointer;margin-left:7px"
        :src="images.logout"
      />
    </v-toolbar>
    <v-content>
      <v-container fluid>
        <router-view></router-view>
      </v-container>
    </v-content>

    <v-dialog v-model="dialog" max-width="500" height="auto">
      <v-card>
        <v-card-title class="headline"
          ><v-icon style="margin-right:10px;">mdi-bullhorn-outline</v-icon
          >Report Problem</v-card-title
        >
        <v-card-text>
          <v-flex xs12 v-model="valid">
            <v-text-field
              :rules="[() => !!topic || 'This field is required']"
              ref="topic"
              label="Topic"
              v-model="topic"
              prepend-icon="mdi-alert-octagram"
              required
              color="#538795"
            ></v-text-field>
            <v-textarea
              v-model="details"
              ref="details"
              :rules="[() => !!details || 'This field is required']"
              label="Details"
              counter
              prepend-icon="mdi-message-draw"
              maxlength="240"
              color="#538795"
            ></v-textarea>
          </v-flex>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="error" text @click="dialog = false" v-if="dialog">
            Close
          </v-btn>

          <v-btn
            color="green white--text"
            text
            :disabled="!valid"
            @click="reportProblem"
          >
            Send
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
import { sync } from "vuex-pathify";
import moment from "moment";
export default {
  data() {
    return {
      companyName: this.$cookies.get("companyName"),
      itemsCompany: [],
      datacompany: "",
      eachcompany: "",
      role: this.$cookies.get("role"),
      mobileView: false,
      dialogloader: false,
      updateDate: "",
      dialogtimeout: false,
      tout: "",
      valid: true,
      nameENG: this.$cookies.get("nameENG"),
      firstlastTH: this.$cookies.get("firstlastTH"),
      bizNameTH: this.$cookies.get("bizNameTH"),
      bizType: this.$cookies.get("bizType"),
      imageCompany: localStorage.getItem("imageCompany"),
      details: "",
      topic: "",
      email: "",
      getname: "",
      firstnameENG: this.$cookies.get("firstnameENG"),
      drawer: false,
      mini: false,
      dialog: false,
      showNav: true,
      drawerinv: false,
      direction: "top",
      fab: false,
      hover: true,
      transition: "slide-y-transition",
      bills: [],
      overdue: "",
      notiMenu: false,
      message: false,
      shownoti: true,
      notidialog: false,
      drawerUpload: true,
      images: {
        logo: require("../assets/inetlogo.png"),
        logoinet: require("../assets/inet_logo.jpg"),
        user: require("../assets/user.png"),
        logout: require("../assets/logout.png")
      },
      Uploadmenu: [
        {
          title: "Detail",
          icon: "mdi-file-document",
          path: "/unpaidbill",
          value: "Unpaidbill"
        },
        {
          title: "Upload PV",
          icon: "mdi-cloud-upload",
          path: "/uploadbill",
          value: "Uploadbill"
        }
      ],
      itemsuser: [
        {
          title: "แดชบอร์ด",
          icon: require("../assets/icon/dashbord.png"),
          path: "/maindashboard",
          value: "maindashboard"
        },
        {
          title: "สั่งจ่ายเงิน",
          icon: require("../assets/icon/pay.png"),
          path: "/unpaidbill",
          value: "Unpaidbill"
        },
        {
          title: "อัปโหลดรายการชำระเงิน",
          icon: require("../assets/icon/upload.png"),
          path: "/uploadbill",
          value: "Uploadbill"
        },
        {
          title: "ประวัติการทำรายการ",
          icon: require("../assets/icon/time money.png"),
          path: "/transaction",
          value: "Transaction"
        },
        {
          title: "ประวัติการนำส่งภาษี",
          icon: require("../assets/icon/report tax.png"),
          path: "/paytax",
          value: "Paytax"
        }
      ],
      itemsadmin: [
        {
          title: "แดชบอร์ด",
          icon: require("../assets/icon/dashbord.png"),
          path: "/maindashboard",
          value: "maindashboard"
        },
        {
          title: "สั่งจ่ายเงิน",
          icon: require("../assets/icon/pay.png"),
          path: "/unpaidbill",
          value: "Unpaidbill"
        },
        {
          title: "ประวัติการทำรายการ",
          icon: require("../assets/icon/time money.png"),
          path: "/transaction",
          value: "Transaction"
        },
        {
          title: "ประวัติการนำส่งภาษี",
          icon: require("../assets/icon/report tax.png"),
          path: "/paytax",
          value: "Paytax"
        },
        {
          title: "Admin Mangement",
          icon: require("../assets/icon/admin.png"),
          path: "/adminmanagement",
          value: "AdminManagement"
        },
        {
          title: "ประเมินความเสี่ยง",
          icon: require("../assets/icon/warning.png"),
          path: "/riskassessment",
          value: "RiskAssessment"
        }
      ],
      custName: this.$cookies.get("custName"),
      userimage: localStorage.getItem("image")
    };
  },
  beforeCreate() {
    if (!this.$session.exists()) {
      this.$router.push("/");
    }
  },
  methods: {
    async checkField() {
      this.formHasErrors = false;
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) this.formHasErrors = true;
        this.dialogloader = false;
        this.$refs[f].validate(true);
      });
    },
    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
      this.$cookies.set("screenView", this.mobileView);
    },
    sessionTimeout() {
      if (this.isIdle == true) {
        this.$session.destroy();
        this.dialogtimeout = true;
      }
    },
    alertReport() {
      this.$alert("Feedback summitted", "Success", "success");
      this.clearForm();
    },
    clearForm() {
      Object.keys(this.form).forEach(f => {
        this.$refs[f].reset();
      });
    },
    async reportProblem() {
      this.dialogloader = true;
      await this.checkField();
      if (this.formHasErrors == false) {
        try {
          let { data: info } = await this.axios.post(
            process.env.VUE_APP_APIHOST + "/report_problem",
            {
              subject:
                "TDCP (" +
                this.$cookies.get("nameTH") +
                ") : " +
                this.topic +
                " [INET Payment Portal-Platform]",
              detail: this.details,
              username: this.$cookies.get("username")
            },
            { headers: { Authorization: this.$cookies.get("token") } }
          );
          // console.log('/report_problem: ', info)
          this.alertReport();
          this.dialog = false;
          this.dialogloader = false;
        } catch (error) {
          console.log(error.message);
          // alert('Something went wrong.Please try again.')
        }
      }
    },
    logout() {
      this.$session.destroy();
      this.clearCookie();
      if (this.role === "Admin") {
        this.$router.push("/admin");
      } else {
        this.$router.push("/");
      }
      localStorage.setItem("image", "null");
    },
    clearCookie() {
      this.$cookies.keys().forEach(key => {
        if (key !== "checkchkbox") {
          let keyremove = key;
          this.$cookies.remove(keyremove);
        }
      });
    },
    async CompanysList() {
      try {
        var { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/companys_list`,
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        // console.log('list_companys: ', data);
        this.itemsCompany = data;
        if (this.role == "Admin") {
          this.companyName = this.itemsCompany[0];
        }
      } catch (error) {
        console.log(error.message);
      }
    }
  },
  computed: {
    tokenHashTaxid: sync("tokenHashTaxid"),
    exportfrom: sync("exportfrom"),
    username() {
      return this.$cookies.get("username");
    },
    isIdle() {
      this.tout = this.$store.state.idleVue.isIdle;
      return this.tout;
    },
    form() {
      return {
        topic: this.topic,
        details: this.details
      };
    }
  },
  created() {
    var arr = ["foo", "bar", "baz"];
    var json_str = JSON.stringify(arr);
    this.$cookies.set("data", JSON.stringify(json_str));
    // this.$cookies.set("data", arr)
    this.handleView();
    window.addEventListener("resize", this.handleView);
    this.CompanysList();
  },
  watch: {
    tout() {
      this.sessionTimeout();
    },
    dialog() {
      this.clearForm();
    },
    // tokenHashTaxid(data) {
    //   console.log('dashboard tokenHashTaxid: ', data)
    // },
    async companyName(val) {
      // console.log("watch: ", val);

      this.$cookies.set("companyName", val);

      var { data } = await this.axios.get(
        `${process.env.VUE_APP_APIHOST}/company_token/` +
          this.$cookies.get("companyName"),
        {
          headers: {
            Authorization: this.$cookies.get("token")
          }
        }
      );
      // console.log('companys_token: ', data)
      this.$cookies.set("token", data);
      this.tokenHashTaxid = data;
    }
  }
};
</script>

<style>
.bizname {
  white-space: normal;
}

.v-list__tile__title {
  color: #aeaeae;
  font-weight: 500;
  font-size: 14px;
  line-height: 24px;
  font-family: "Sarabun", sans-serif;
}
.inputbiz .v-input__slot {
  max-height: 32px;
  font-size: 12px;
  overflow: hidden;
  white-space: pre;
  text-overflow: ellipsis;
}
.sidemenu {
  color: #3a8300 !important;
  /* background-color: #fff7d2 !important; */
  background-color: #ecf8ea !important;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 24px;
  font-family: "Sarabun", sans-serif;
}
.transparent :hover {
  cursor: pointer;
}
.v-speed-dial {
  position: absolute;
}
.v-btn--floating {
  position: relative;
}
.btm {
  padding-left: 32%;
  padding-bottom: 15px;
  position: absolute;
  bottom: 0px;
  font-size: 13px;
}
.items {
  max-height: 200px;
  overflow: auto;
}
.v-select.v-text-field--enclosed:not(.v-text-field--single-line)
  .v-select__selections {
  padding-top: 0px;
}

@media (max-width: 578px) {
  .inputbiz .v-input__slot {
    max-height: 32px;
    width: 189px;
    font-size: 12px;
    overflow: hidden;
    white-space: pre;
    text-overflow: ellipsis;
  }
}
</style>
